unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Splitter1: TSplitter;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    mdb;

//  ---------------------------------------------------------------------------
//  f[^x[X쐬
procedure TForm1.Button1Click(Sender: TObject);
var
    ret: Boolean;
    Err: string;
begin
    ret := CreateDatabase(ExtractFilePath(ParamStr(0)) + Edit1.Text, Err);
    if ret then ShowMessage('') else ShowMessage(Err);
end;

var
    DB: TPoorMdb = nil;

//  ---------------------------------------------------------------------------
//  f[^x[XJ
procedure TForm1.BitBtn1Click(Sender: TObject);
var
    ret: Boolean;
    Err: string;
begin
    DB := TPoorMdb.Create(ExtractFilePath(ParamStr(0)) + Edit1.Text, '');
    ret := DB.Open(Err);
    if ret then
    begin
        ShowMessage('');
        BitBtn1.Enabled := false;
        BitBtn2.Enabled := true;
        BitBtn3.Enabled := true;
    end
    else
    begin
        ShowMessage(Err);
    end;
end;

//  ---------------------------------------------------------------------------
//  f[^𑀍삷(e[u쐬Ef[^쐬EXVE폜)
procedure TForm1.BitBtn2Click(Sender: TObject);
var
    i: integer;
    ret: Boolean;
    SQL, Err: string;
begin
    if (DB = nil) then exit;

    Screen.Cursor := crHourGlass;
    BitBtn2.Enabled := false;
    BitBtn3.Enabled := false;
    Memo2.Clear();
    //  gUNVJn
    DB.BeginTrans();
    try
        for i := 0 to Memo1.Lines.Count - 1 do
        begin
            //  1sNG[ƂĈ
            SQL := Memo1.Lines[i];
            //  ̂܂܎s
            ret := DB.Execute(SQL, Err);
            //  肪Ε\
            if not ret then Memo2.Lines.Add(Err);
        end;
        //  R~bg
        DB.Commit();
    except
        on E:Exception do
        begin
            Memo2.Lines.Add(E.Message);
            try
                //  [obN
                DB.Rollback();
            except
                //  D
                on E:Exception do Memo2.Lines.Add(E.Message);
            end;
        end;
    end;
    Screen.Cursor := crDefault;
    BitBtn2.Enabled := true;
    BitBtn3.Enabled := true;
end;

//  ---------------------------------------------------------------------------
//  f[^x[X
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
    if (DB = nil) then exit;
    DB.Close();
    DB.Free();
    DB := nil;
    BitBtn1.Enabled := true;
    BitBtn2.Enabled := false;
    BitBtn3.Enabled := false;
end;

end.

